/**
\author		Korotkov Andrey aka DRON
\date		13.03.2011 (c)Korotkov Andrey

This file is a part of DGLE2 project and is distributed
under the terms of the GNU Lesser General Public License.
See "DGLE2.h" for more details.
*/

#if _MSC_VER > 1000
#pragma once
#endif

#ifndef _MUSICMCI_H
#define _MUSICMCI_H

#include "..\stdafx.h"
#include "Core.h"
#include "ResourceManager.h"
#include <MMSystem.h>

//Extended MMSystem

#define	MCI_SETAUDIO			0x0873
#define	MCI_DGV_SETAUDIO_VOLUME	0x4002
#define	MCI_DGV_SETAUDIO_ITEM	0x00800000
#define	MCI_DGV_SETAUDIO_VALUE	0x01000000

struct MCI_DGV_SETAUDIO_PARMS
{
	DWORD dwCallback;
	DWORD dwItem;
	DWORD dwValue;
	DWORD dwOver;
	LPCTSTR	lpstrAlgorithm;
	LPCTSTR	lpstrQuality;
};

class CResourceManager;

class CMusicMCI : public CInstancedObj, public IMusic
{
	friend class CResourceManager;

	TWinHandle		_stWnd;
	MCIDEVICEID		_uiDevId;
	uint			_uiVolume;
	bool			_bIsPlaying;
	bool			_bIsLoop;
	string			_tmpFileName;

	void			_MessageProc(const TWinMessage &msg);
	static void CALLBACK _s_MessageProc(void *pParametr, const TWinMessage &stMsg);

public:

	CMusicMCI(uint uiInstIdx, IFile *pFile);
	CMusicMCI(uint uiInstIdx, MCIDEVICEID uiDevId);

	~CMusicMCI();

	HRESULT CALLBACK Play(bool bLooped);
	HRESULT CALLBACK Pause(bool bPaused);
	HRESULT CALLBACK Stop();
	HRESULT CALLBACK IsPlaying(bool &bIsPlaying);
	HRESULT CALLBACK SetVolume(uint uiVolume);
	HRESULT CALLBACK GetVolume(uint &uiVolume);
	HRESULT CALLBACK SetCurrentPosition(uint uiPos);
	HRESULT CALLBACK GetCurrentPosition(uint &uiPos);
	HRESULT CALLBACK GetLength(uint &uiLength);

	HRESULT CALLBACK Free();
	HRESULT CALLBACK GetType(E_ENG_OBJ_TYPE &eObjType);

	IDGLE2_BASE_IMPLEMENTATION1(IMusic, IEngBaseObj)	
};

#endif //_MUSICMCI_H